/*
 * Copyright (c) 2014 - Zephyr Software LLC
 *
 * This file may be used and modified for non-commercial purposes as long as
 * all copyright, permission, and nonwarranty notices are preserved.
 * Redistribution is prohibited without prior written consent from Zephyr
 * Software.
 *
 * Please contact the authors for restrictions applying to commercial use.
 *
 * THIS SOURCE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Author: Zephyr Software
 * e-mail: jwd@zephyr-software.com
 * URL   : http://www.zephyr-software.com/
 *
 */

#ifdef DEBUG
#include "malloc.h"
#include "itox.h"
#include "strlen.h"
#include "null.h"

#define DEBUG_ADD
#else

typedef unsigned uintptr_t;
#define NULL 0L

#endif


#ifdef DEBUG
	#define print_str_debug print_str
	#define print_int_debug print_int
#else
	#define print_str_debug(a) 
	#define print_int_debug(a) 
	#define assert(a)
#endif


#ifdef DEBUG
#define write_fd 2
void print_str(char *s)
{
	write(write_fd,s,strlen(s));
}
void print_int(int x)
{
	char buf[100];
	itox(x,buf);
	write(write_fd,buf,strlen(buf));
}
#endif

unsigned long long read_random64(void) {
	unsigned long long random_value = -1;
	int fd = -1;
	fd = open("/dev/urandom", 0x00);
	if (fd != -1) {
		read(fd, (void*)&random_value, sizeof(unsigned long long));
		close(fd);
	}
	return random_value;
}

unsigned long read_random32(void) {
	unsigned long random_value = -1;
	int fd = -1;
	fd = open("/dev/urandom", 0x00);
	if (fd != -1) {
		read(fd, (void*)&random_value, sizeof(unsigned long));
		close(fd);
	}
	return random_value;
}
void set_canary64(unsigned long long new_canary) {
	asm volatile ("mov %0, %%fs:0x28\n"
	    : 
	    : "r" (new_canary)
	    :);
}

void set_canary32(unsigned long new_canary) {
	asm volatile ("mov %0, %%fs:0x28\n"
	    : 
	    : "r" (new_canary)
	    :);
}

/*
 */
#define FORK 57
void zipr_hook_dynamic_callback(unsigned int id, unsigned int rax)
{
#ifdef DEBUG
	print_str_debug("In zipr_hook_dynamic_callback, id=");
	print_int_debug(id);
	print_str_debug(", rax=");
	print_int_debug(rax);
	print_str_debug("\n");
#endif
	if (id == FORK && rax!=0) {
		/*
		 * Child!
		 */
		set_canary32(read_random32());
	}
}
